COLOR = true
if COLOR
  NORMAL = "\x1B[0m"
  BRIGHT = "\x1B[1m"
else
  NORMAL = BRIGHT = ""
end

require 'socket'
include Socket::Constants


def dissect(str)
  puts "#{str.class}: #{str.inspect}"

  ords = []
  (0..(str.length-1)).each do |i|
    begin
      ords << str[i].ord
    rescue
      ords << nil
    end
  end
  ordlist = ords.inspect
    

  #begin
  #  codelist = str.codepoints.to_a.to_s
  #rescue
  #  codelist = "N/A"
  #end

  format = "  %-11s = %s"
  #bright = BRIGHT + format + NORMAL

  puts format % [".encoding", str.encoding]
  puts format % [".bytes (#{str.bytesize})", str.bytes.to_a.to_s]
  puts format % [".chars (#{str.length})", str.chars.to_a.to_s]
  puts format % ["[i].ord", ordlist]
  puts format % [".valid_encoding?", false] if !str.valid_encoding?
  #puts format % [".codepoints", codelist]
  puts
end

def send_through_socket(str)
  # Server setup
  server_socket = Socket.new(AF_INET, SOCK_STREAM, 0)
  server_socket.bind(Socket.pack_sockaddr_in(2200, 'localhost'))
  server_socket.listen(1)
  
  # Client connect
  client_socket = Socket.new(AF_INET, SOCK_STREAM, 0)
  #client_socket.external_encoding = "UTF-8"
  #puts client_socket.external_encoding.inspect
  #puts client_socket.internal_encoding.inspect
  client_socket.connect(Socket.pack_sockaddr_in(2200, '127.0.0.1'))
  
  # Server accept connection
  remote_socket, remote_addr = server_socket.accept

  # Client send data and close
  client_socket.puts str
  client_socket.close

  # Server receive data
  received_string = remote_socket.recvfrom(str.bytesize)[0]
  remote_socket.close
  server_socket.close

  return received_string
end
